﻿Imports System.Text
Imports System.Security.Cryptography
Imports System.IO

Module Module1

    Sub Main()
        Console.WriteLine(EncryptData("Test"))
        Console.WriteLine(DecryptData(EncryptData("Test")))
        Console.WriteLine(HashData("Test"))

        Console.ReadLine()
    End Sub
    Function HashData(ByVal PlainText As String)
        Dim UnicodeString As New UnicodeEncoding()

        'Convert the string into a byte array
        Dim PlainTextByte As Byte() = UnicodeString.GetBytes(PlainText)

        'Initalize the MD5 provider
        Dim MD5 As New MD5CryptoServiceProvider()

        'Computer the hash and store it as a byte array
        Dim HashedByte As Byte() = MD5.ComputeHash(PlainTextByte)

        'Convert the byte array and return as a string value
        Return Convert.ToBase64String(HashedByte)

    End Function
    Function EncryptData(ByVal plainText As String)
        'Setting the Passphrase, salting value, and vector which will be used to encrypt the values.  These must be the same in your encryption and decryption functions.
        Dim PassPhrase As String = "YourStrongPassword!"
        Dim SaltValue As String = "Your$altValue"
        Dim PasswordIterations As Integer = 2
        Dim initVector = "d83jd72hs0wk3ldf"

        'Convert the text values into byte arrays
        Dim initVectorBytes() As Byte = Encoding.ASCII.GetBytes(initVector)
        Dim SaltValueBytes() As Byte = Encoding.ASCII.GetBytes(saltValue)
        Dim plainTextBytes() As Byte = Encoding.UTF8.GetBytes(plainText)

        'Create the password which will be used to encrypt the value based on the Passphrase, salt value, SHA1 hash, and Password Iterations specified.
        Dim password As PasswordDeriveBytes = New PasswordDeriveBytes(PassPhrase, SaltValueBytes, "SHA1", PasswordIterations)

        'Create an array to hold the pseudo-random bytes for the encryption key.
        Dim KeyBytes As Byte() = password.GetBytes(32)

        'Create an object to use for encryption.
        Dim SymmetricKey As RijndaelManaged = New RijndaelManaged()

        'Set the encryption object for Ciopher Block Chaining.
        SymmetricKey.Mode = CipherMode.CBC

        'Generate the encryptor from the key bytes and the vector bytes.
        Dim Encryptor As ICryptoTransform = SymmetricKey.CreateEncryptor(KeyBytes, initVectorBytes)

        'Create a memory stream object to hold the encrypted data.
        Dim memoryStream As MemoryStream = New MemoryStream()

        'Create cryptographic steam to do the encryption.
        Dim CryptoStream As CryptoStream = New CryptoStream(memoryStream, Encryptor, CryptoStreamMode.Write)

        'Begin the encryption.
        CryptoStream.Write(plainTextBytes, 0, plainTextBytes.Length)

        'Finish the encryption.
        CryptoStream.FlushFinalBlock()

        'Convert the encrypted value into a new byte array.
        Dim CipherTextBytes As Byte() = memoryStream.ToArray()

        'Close the streams.
        memoryStream.Close()
        CryptoStream.Close()

        'Convert the encrypted value to a string value and return to the calling code.
        Return Convert.ToBase64String(CipherTextBytes)

    End Function

    Function DecryptData(ByVal EncryptedValue As String)
        'Setting the Passphrase, salting value, and vector which will be used to encrypt the values.  These must be the same in your encryption and decryption functions.
        Dim PassPhrase As String = "YourStrongPassword!"
        Dim SaltValue As String = "Your$altValue"
        Dim PasswordIterations As Integer = 2
        Dim initVector = "d83jd72hs0wk3ldf"

        'Convert the text values into byte arrays
        Dim initVectorBytes() As Byte = Encoding.ASCII.GetBytes(initVector)
        Dim SaltValueBytes() As Byte = Encoding.ASCII.GetBytes(SaltValue)
        Dim CipherTextBytes() As Byte = Convert.FromBase64String(EncryptedValue)

        'Create the password which will be used to decrypt the value based on the Passphrase, salt value, SHA1 hash, and Password Iterations specified.
        Dim Password As PasswordDeriveBytes = New PasswordDeriveBytes(PassPhrase, SaltValueBytes, "SHA1", PasswordIterations)

        'Create an array to hold the pseudo-random bytes for the encryption key.
        Dim KeyBytes As Byte() = Password.GetBytes(32)

        'Create an object to use for encryption.
        Dim SymmetricKey As RijndaelManaged = New RijndaelManaged()

        'Set the encryption object for Ciopher Block Chaining.
        SymmetricKey.Mode = CipherMode.CBC

        'Generate the decryptor from the key bytes and the vector bytes.
        Dim Decrypter As ICryptoTransform = SymmetricKey.CreateDecryptor(KeyBytes, initVectorBytes)

        'Create a memory stream object to hold the decrypted data.
        Dim memoryStream As MemoryStream = New MemoryStream(CipherTextBytes)

        'Create cryptographic steam to do the decryption.
        Dim CryptoStream As CryptoStream = New CryptoStream(memoryStream, Decrypter, CryptoStreamMode.Read)

        'Create a byte array based on the size of the memorystream object
        Dim PlainTextBytes() As Byte = memoryStream.ToArray

        'Decrypt the data
        Dim decryptedByteCount As Integer = CryptoStream.Read(PlainTextBytes, 0, PlainTextBytes.Length)

        'close the streams
        memoryStream.Close()
        CryptoStream.Close()

        'Convert the decrypted value to a string value and return to the calling code
        Return Encoding.UTF8.GetString(PlainTextBytes, 0, decryptedByteCount)

    End Function

End Module
