use master
GO
IF EXISTS (SELECT * FROM sys.databases WHERE name = 'HashingDemo')
	DROP DATABASE HashingDemo
GO
CREATE DATABASE HashingDemo
GO
USE HashingDemo
GO
CREATE FUNCTION dbo.HashValue (@value varchar(255), @salt varchar(255))
returns varbinary(255)
as
begin
	return HASHBYTES ('sha2_256', cast(HASHBYTES ('sha2_256', @value) as varchar(256)) + @salt)
end
go
select HASHBYTES('sha2_256', 'test')
select dbo.HashValue ('test', 'test')
select dbo.HashValue ('test', 'test1')
GO
USE master 
GO
IF EXISTS (SELECT * FROM sys.databases WHERE name = 'HashingDemo')
	DROP DATABASE HashingDemo
GO
